clearvars global
clear
clc

%Get the competitive equilibrium in the Ales et al assignment model
global n_k n_v  v b   n index_pareto_start index_pareto_constant



%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%
%First of all, get the income distribution%
%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%


%Define Income grid

                                
income_start=2500;
income_end=1002500

n=(income_end-income_start)/2500+1;

 income=linspace(income_start,income_end,n)';

n_k=n;
el_sub=1.00001;
elasticity=.33;

rho=1-1./el_sub;

mu_inc=10;
sigma=.95;
pareto=2.5;
exp(mu_inc+sigma^2/2)



pareto_start=150000
index_pareto_start=find(income>pareto_start,1,'first');


pareto_constant=350000;
index_pareto_constant=find(income>pareto_constant,1,'first');

cutoff=index_pareto_constant;
pareto_paraeter_start=1/((1-logncdf(pareto_start,mu_inc,sigma))./(lognpdf(pareto_start,mu_inc,sigma).*pareto_start))


pareto_vector=linspace(pareto_paraeter_start-1.55,0,index_pareto_constant-index_pareto_start+1);
if pareto_paraeter_start-pareto_paraeter_start>1
    disp('uncorrect smoothing')
    return
end
vector_help=linspace(0,(pareto_paraeter_start-1.55),index_pareto_constant-index_pareto_start+1);

vector = 1./(1+exp(-1 .*(vector_help-(pareto_paraeter_start-1.5)./2)));
vector=vector';
vector2=flipud(vector_help');

pareto_vector=1.5+vector2;

plot(pareto_vector)

pareto_vector_big=zeros(n,1);

pareto_vector_big(index_pareto_start:index_pareto_constant) = pareto_vector;
pareto_vector_big(index_pareto_constant:n) = ones(n-index_pareto_constant+1,1)*1.5;


pmf=lognpdf(income,mu_inc,sigma);
interesting=zeros(n,1);
for i=index_pareto_start:index_pareto_constant
    if i>index_pareto_start
        pmf(i) = ( pareto*x_min^pareto*income(i)^(-pareto-1));
        
    end
    pareto=pareto_vector(i-index_pareto_start+1);
    x_min = ((pmf(i)*income(i)^(pareto+1))/pareto)^(1/pareto);
    
    pmf(i) = ( pareto*x_min^pareto*income(i)^(-pareto-1));
    interesting(i) = x_min;
    
end
for i=index_pareto_constant:n
    pmf(i) = ( pareto*x_min^pareto*income(i)^(-pareto-1));
end

pmf= ksdensity(income,income,'weights',pmf,'width',20000);


pmf=pmf./sum(pmf);

cdf=cumsum(pmf);



%%Now get wages and labor supply

%Start with tax function calibration

tau_tax=-3;
p_tax=.15

t_prime = 1 - (1-tau_tax) .* income.^(-p_tax);

Tax = income - (1-tau_tax)/(1-p_tax) .*income.^(1-p_tax);


y=income;
t_prime_prime = (t_prime(2:n)-t_prime(1:n-1))./(y(2:n)-y(1:n-1));
t_prime_prime(n,1)=t_prime_prime(n-1,1);

wage_cal = ((income.^(1/elasticity))./(1-t_prime)).^(1/(1+(1/elasticity)));%wages given current policies


l_cal=income./wage_cal;%hours worked given current policies


%Given that we knwo GDP, wages and hours worked, we can easily get productivities
gdp_cal=sum(pmf.*income);






%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%
%So far nothing with assignment. Let's get to assignment now. Let's first
%get the b parameters of the task production function from Ales et al
%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%


%Start with the vector we take directly from the Mat File of Ales et al
b_ales=[0.00359293486944233;0.00357648824167519;0.00355928748759483;0.00354137610168095;0.00352279736829065;0.00350359078411337;0.00348380602292827;0.00346349218087325;0.00344273213311488;0.00342162772522719;0.00340028883980767;0.00337881947555132;0.00335731444108259;0.00333586288121490;0.00331454507153744;0.00329341618741915;0.00327252016552297;0.00325189980486380;0.00323159357001113;0.00321164536600115;0.00319210119218825;0.00317302179318240;0.00315446017806324;0.00313646503557112;0.00311907779903803;0.00310234842424542;0.00308631363672743;0.00307100349922145;0.00305643554035335;0.00304262120045896;0.00302956298849050;0.00301726074258341;0.00300570268994413;0.00299488064962451;0.00298478698025206;0.00297541754645394;0.00296675386667258;0.00295878698180233;0.00295149665063918;0.00294486619341578;0.00293888242313573;0.00293352972094880;0.00292879882284095;0.00292467212650536;0.00292114709794026;0.00291820406520323;0.00291583252945812;0.00291401944555235;0.00291274629725781;0.00291200072964244;0.00291176486713589;0.00291202111371889;0.00291275794826630;0.00291395533782974;0.00291559927218618;0.00291767300039172;0.00292015115659751;0.00292301430744575;0.00292623431848905;0.00292977720502851;0.00293361772816053;0.00293772766926743;0.00294207284105357;0.00294662480342611;0.00295135203084651;0.00295621986899026;0.00296120233731051;0.00296626439266729;0.00297137670038513;0.00297651865463858;0.00298165758036698;0.00298676953694293;0.00299182144512037;0.00299678300277023;0.00300162971919482;0.00300633395378940;0.00301086791453911;0.00301520668750284;0.00301932525491406;0.00302320758172738;0.00302682852790666;0.00303017199185398;0.00303321884549329;0.00303594997127649;0.00303835539607622;0.00304042826122302;0.00304215875718307;0.00304353716728639;0.00304454474483364;0.00304517807600473;0.00304542474541886;0.00304529379497026;0.00304478527336924;0.00304391154538174;0.00304268205349149;0.00304112155789939;0.00303925184313751;0.00303709474019104;0.00303467514002186;0.00303201489661130;0.00302913282108874;0.00302604468083051;0.00302276924840797;0.00301931619695188;0.00301570122195031;0.00301193997433201;0.00300804805261482;0.00300403498778137;0.00299991327794444;0.00299569836365475;0.00299139962803541;0.00298702939719640;0.00298261186346985;0.00297817108099780;0.00297373393662917;0.00296932715763542;0.00296498324319787;0.00296072266138666;0.00295656872351682;0.00295253576033278;0.00294864688153475;0.00294491331165182;0.00294134918014861;0.00293796563484612;0.00293477967083034;0.00293179358530085;0.00292901263295900;0.00292643916206078;0.00292406678203048;0.00292190085112151;0.00291993507340710;0.00291817488330849;0.00291661699391429;0.00291526691281400;0.00291411560978075;0.00291315411028567;0.00291237931434476;0.00291177942599663;0.00291134851452982;0.00291107777170770;0.00291097588576871;0.00291105157212565;0.00291130484462962;0.00291173574963281;0.00291234145365977;0.00291311623952840;0.00291406024211016;0.00291517362576539;0.00291645950084897;0.00291792393105962;0.00291957302390553;0.00292140709160152;0.00292343817525000;0.00292566375842836;0.00292809306737160;0.00293073246809677;0.00293358839212992;0.00293665559433373;0.00293993179146189;0.00294341473219701;0.00294709040692675;0.00295095657617044;0.00295501102228985;0.00295924858857589;0.00296365819185920;0.00296823464627583;0.00297296681223683;0.00297783754451512;0.00298283855058548;0.00298795850780813;0.00299319500637187;0.00299854263079315;0.00300398091563824;0.00300948925277190;0.00301504387073781;0.00302061176147909;0.00302617177737611;0.00303169048837351;0.00303714333409563;0.00304251166806733;0.00304777672106811;0.00305291960685429;0.00305793050282111;0.00306279954254513;0.00306752295509484;0.00307209697109362;0.00307651474785347;0.00308077251131454;0.00308486032528624;0.00308876823164083;0.00309248934825441;0.00309601679637482;0.00309935300268914;0.00310249734054374;0.00310545232436106;0.00310822051542805;0.00311080763098772;0.00311321944135754;0.00311547111289482;0.00311757788337533;0.00311956129356674;0.00312144607773557;0.00312325391833393;0.00312501905540205;0.00312676642939955;0.00312852729453633;0.00313033297567419;0.00313222113568155;0.00313422953305211;0.00313639603409936;0.00313875235220767;0.00314133032600227;0.00314415565175899;0.00314725731810184;0.00315066449346950;0.00315440339829105;0.00315849415533322;0.00316295709917741;0.00316780963092571;0.00317307573501139;0.00317877652088038;0.00318493340831582;0.00319157134736868;0.00319871568529457;0.00320639540981749;0.00321463358549822;0.00322346020655683;0.00323290263047384;0.00324298233728615;0.00325371487131135;0.00326512282563539;0.00327721960300045;0.00329002242511501;0.00330354581461220;0.00331779823566873;0.00333278530029762;0.00334851974459047;0.00336500477090624;0.00338225071838016;0.00340026503786909;0.00341904879030302;0.00343861708677191;0.00345896835355799;0.00348010818483150;0.00350203553509606;0.00352474953873397;0.00354825658804615;0.00357255269503709;0.00359762671020719;0.00362347815518457;0.00365009202971990;0.00367745663298750;0.00370555994987651;0.00373437840697117;0.00376390650029713;0.00379412334261389;0.00382501114461248;0.00385655146343275;0.00388871349129812;0.00392145744108494;0.00395473810730111;0.00398850064027150;0.00402268616968696;0.00405722921348175;0.00409206110551087;0.00412710949129060;0.00416230156000645;0.00419756535948279;0.00423282441609107;0.00426800105615482;0.00430301904960376;0.00433779815102209;0.00437225056905392;0.00440629403328622;0.00443985927400729;0.00447288082497828;0.00450530945834898;0.00453709927162877;0.00456820286273668;0.00459856905866619;0.00462813732204935;0.00465685152276185;0.00468466815075307;0.00471154076517570;0.00473744651624774;0.00476237970289156;0.00478633499062212;0.00480930643252400;0.00483126424034698;0.00485217511095012;0.00487201534921553;0.00489073833527754;0.00490829033666346;0.00492461146372806;0.00493965001190961;0.00495339242832422;0.00496587383447536;0.00497714374292228;0.00498728254316945;0.00499640213740449;0.00500460195882558;0.00501194709292867];

b=b_ales;

n_v=numel(b);

v_help=linspace(0.0001,1,numel(b_ales));
%

n_v=100;
v=linspace(0,1,n_v);

b=interp1(v_help,b_ales,v,'spline');



%normalization for constant returns to scale

b=b./trapz(v,b);






%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%
%Now first solve the matching ODE for Fixed Wages.




doof=matching_fixed_wage(l_cal,gdp_cal,wage_cal,cdf);

match_initial=doof';



%%%%%%%%%%%%%%%%%%%%%%%%%%%
%Based on that, get the A'/A function. For the impact of the M, we take
%the parameter from Ales et al to capture the complementarity.



dwage=    [(wage_cal(2:n)-wage_cal(1:n-1));0];
dwage(n)=dwage(n-1);

a_prime_a = dwage./(pmf.*wage_cal);

%Now fit an auxiliary function such that the ODE for the wages holds!
auxil=a_prime_a - match_initial*3.0138;




%Now double check whether everything works: Solve the system of ODE
%jointly. We should obtain exactly the wage distribution we started with.

doof=matching_manual_auxil2(l_cal,gdp_cal,wage_cal(1)*.5,wage_cal(1)*15,cdf,auxil);


hazard=(1-cdf)./(pmf.*wage_cal).*dwage;

wage_alt = doof(2,:)';
 

m=doof(1,:);
grid_size=zeros(n,1);
grid_size(1:n-1)=cdf(2:n)-cdf(1:n-1);
grid_size(n)=grid_size(n-1);



m_prime_up =   (m(1,3:end)-m(1,2:end-1))./grid_size(2:end-1)';

m_prime_down = (m(1,2:end-1)-m(1,1:end-2))./grid_size(1:end-2)';
m_prime=0.5*m_prime_up+0.5*m_prime_down;

aux1=(m(1,2)-m(1,1))/(cdf(2)-cdf(1));

aux2=(m(1,end)-m(1,end-1))/(cdf(n)-cdf(n-1));
size(m_prime_up)
m_prime=[aux1,m_prime,aux2];






matching_initial=m;
labor_initial=l_cal;
wage_initial=wage_alt;
m_prime_initial =m_prime;

labor=l_cal;

gdp=sum(pmf.*wage_alt.*labor)

loop=0



options=optimset('TolCon',1e-13,'TolFun',1e-13,'TolX',1e-13,'Display','off','MaxFunEvals',10000000,'MaxIter',2000);

labor_dev=1;
while(labor_dev>0.00000001)
    loop=loop+1
    
    
    %Get matching for the new labor supply and new gdp guess
    doof=matching_manual_auxil2(labor,gdp,wage_cal(1)*.5,wage_cal(1)*15,cdf,auxil);
    m=doof(1,:);
    w=doof(2,:);
    m_prime=doof(3,:);
    
    
    wage =w';
    
    [factor,fval,exitflag]=fsolve(@fix_scaling,1,options,tau_tax,wage,p_tax,elasticity,pmf,gdp);
    
    wage=factor*wage;
    
    labor_old=labor;
    
    labor = (   ( (1-tau_tax) .* (wage.*1).^(-p_tax)).^elasticity   .*  wage.^elasticity ) .^(1/(1+p_tax*elasticity));
    
     gdp=sum(pmf.*wage.*labor) ;
    
    
    labor_dev=max(abs(labor-labor_old)./labor_old)
    
    
end



matching_initial=m;
labor_initial=labor;
wage_initial=wage;
m_prime_initial =m_prime;


income_initial=    labor_initial.*wage_initial;


save calibration.mat

