
clear
clc

%first load the optimal policy file, where the optimal tax schedule of the
%naive planner is also constructed. 


load optimum.mat

l_pe_naive=(wage_cal.*(1-t_prime_current)).^elasticity;

y_pe_naive=wage_cal.*l_pe_naive;


l_pe=l_pe';
y_pe=y_pe';

w_correct=w_pe';
dw_correct=    [(w_correct(2:n)-w_correct(1:n-1));0];
dw_correct(n)=dw_correct(n-1);
t_prime_naive=t_prime_current;%this is the optimal marginal tax rate schedule of the naive planner as a function of type
t_prime=t_prime_naive;
t_prime_correct = interp1(y_pe_naive,t_prime_naive,y_pe,'spline')%This is the marginal tax rate that applies to each type given the tax schedule o the naive planner. As oppose to t_prime

 





options=optimset('TolCon',1e-13,'TolFun',1e-13,'TolX',1e-13,'Display','off','MaxFunEvals',10000000,'MaxIter',2000);


t_prime_prime_naive = (t_prime_naive(2:n)-t_prime_naive(1:n-1))./(y_pe_naive(2:n)-y_pe_naive(1:n-1));
t_prime_prime_naive(n,1)=t_prime_prime_naive(n-1,1);


t_prime_prime_correct = (t_prime_correct(2:n)-t_prime_correct(1:n-1))./(y_pe(2:n)-y_pe(1:n-1));
t_prime_prime_correct(n,1)=t_prime_prime_correct(n-1,1);

%     %TAX INCIDENCE

 gamma_bar_naive=zeros(n,n);

 gamma_bar_correct=zeros(n,n);

for i=1:n
    
     gamma_bar_correct(:,i) = ones(n,1) * (1-rho)*(a(i).*(pmf(i).*l_pe(i)).^rho)./sum(a.*(pmf.*l_pe).^rho);
    
end



e_tilde_naive=elasticity.*(1-t_prime_naive-y_pe_naive.*t_prime_prime_naive)./(1-t_prime_naive+y_pe_naive.*elasticity.*t_prime_prime_naive);

e_tilde_tau_naive=elasticity.*(1-t_prime_naive)./(1-t_prime_naive+y_pe_naive.*elasticity.*t_prime_prime_naive);

 



e_tilde_correct=elasticity.*(1-t_prime_correct-y_pe.*t_prime_prime_correct)./(1-t_prime_correct+y_pe.*elasticity.*t_prime_prime_correct);

e_tilde_tau_correct=elasticity.*(1-t_prime_correct)./(1-t_prime_correct+y_pe.*elasticity.*t_prime_prime_correct);

e_tilde_tau_ge_correct=e_tilde_tau_correct./(1+e_tilde_correct./el_sub);

e_tilde_ge_correct=e_tilde_correct./(1+e_tilde_correct./el_sub);



dtau=0.01;

for i=1:n
    vector=zeros(n,1);
    vector(i)=1;
     
    d_ln_l_correct(:,i) = - e_tilde_tau_ge_correct(i).*(dtau./(1-t_prime_correct(i))).*vector - e_tilde_tau_ge_correct(i).*(dtau./(1-t_prime_correct(i)))  .* ( gamma_bar_correct(:,i).*e_tilde_ge_correct)...
        ./(1 - sum(e_tilde_ge_correct.*gamma_bar_correct(i,:)'));
    
end




for j=1:n
    %vector=zeros(n,1);
    % vector(j)=1;
    
    
     d_ln_w_correct(:,j) = gamma_bar_correct*d_ln_l_correct(:,j) +(rho-1).*d_ln_l_correct(:,j);
    
end
 





delta_y_naive=    [(y_pe_naive(2:n)-y_pe_naive(1:n-1));0];
delta_y_naive(n)=delta_y_naive(n-1);


delta_y_correct=    [(y_pe(2:n)-y_pe(1:n-1));0];
delta_y_correct(n)=delta_y_correct(n-1);

for j=1:n
    mechanical_naive(j) = delta_y_naive(j)*dtau*(1-cdf(j));
    mechanical_correct(j) = delta_y_correct(j)*dtau*(1-cdf(j));
    
    labor_supply_naive(j) =delta_y_naive(j)    * wage_cal(j) *(pmf(j)/dw_cal(j))   *((1+1/elasticity))^(-1)*t_prime_naive(j)/(1-t_prime_naive(j))*dtau;%it is defined as a tax loss. so it being negative means an increase in tax revenue
    
    labor_supply_correct(j) =delta_y_correct(j)* w_correct(j)*(pmf(j)/dw_correct(j))*((1+1/elasticity))^(-1)*t_prime_correct(j)/(1-t_prime_correct(j))*dtau;%it is defined as a tax loss. so it being negative means an increase in tax revenue
    
end






for j=1:n
    
    for i=1:n
         dy_correct(i,j) = d_ln_l_correct(i,j)*y_pe(i) + d_ln_w_correct(i,j)*y_pe(i);
        
        if i==j
            
             dy_correct(i,j)=   d_ln_l_correct(i,j)*y_pe(i) + d_ln_w_correct(i,j)*y_pe(i) + e_tilde_tau_correct(i)*y_pe(i)*dtau/(1-t_prime_correct(j));
            
        end
        
        delta_tau(i,j)=t_prime_correct(i)*dy_correct(i,j);
        
        
    end
    
    ge_revenue(j) = - sum(pmf.*delta_tau(:,j));%it is defined as a tax loss. so it being negative means an increase in tax revenue
end











l_over_m_naive=  labor_supply_naive./mechanical_naive;
l_over_m_correct=  labor_supply_correct./mechanical_correct;


ge_over_m=    ge_revenue./mechanical_correct;

%Given the boundedness of the distribution (which could be overcome more by
%setting income_end higher, which make the code run longer, the effects are
%made constant here starting from the point where the pareto parameter is
%constant at 1.5

index=cutoff;%
for i=index:n
    l_over_m_naive(i) =  l_over_m_naive(index);
    l_over_m_correct(i) =  l_over_m_correct(index);
    
    ge_over_m(i) =  ge_over_m(index);
end





hold off
p1=plot(y_pe_naive/1000,(1-l_over_m_naive))
set(p1,'Color','red','LineWidth',2);
hold on
p3=plot(y_pe_naive/1000,(1-l_over_m_correct-ge_over_m));
set(p3,'Color','black','LineWidth',2,'LineStyle','--');
xlim([0 500])
ylabel(' Revenue Effect');
h= xlabel('$y^*$ in \$1,000');
set(h,'Interpreter','latex')
set(gca,'FontSize',16)

 hleg1 = legend('$\hat{\mathcal{R}}_{ex}(y^*)$','$\hat{\mathcal{R}}_{ge}(y^*)$');

set(hleg1,'Interpreter','latex')



 