clear

load gamma.mat

t_prime=t_prime';
t_prime_prime=t_prime_prime';
y=income_initial';


elasticity=0.33;

e_tilde=elasticity.*(1-t_prime-y.*t_prime_prime)./(1-t_prime+y.*elasticity.*t_prime_prime);

e_tilde_tau=elasticity.*(1-t_prime)./(1-t_prime+y.*elasticity.*t_prime_prime);


dtau=0.01;



a_term =  B_(matching_initial ).*     m_prime_initial ;






%%%%%%%%%%%CES part for comparison

el_sub = 3.1;
rho = 1-1/el_sub;



%Given that we know GDP, wages and hours worked, we can easily get productivities

x_cal=gdp^rho;

a_ces = wage_initial./((pmf.*labor_initial).^(rho-1).*x_cal.^(1/rho-1));


%%%%%%%%%%%%%

fix=zeros(n_k,1);
for i=1:n_k
    gamma_bar_cd(:,i) =pmf(i)* ones(n_k,1)*a_term(i);
    gamma_bar_ces(:,i) =ones(n_k,1)* (1-rho)*(a_ces(i).*(pmf(i).*labor_initial(i)).^rho)./sum(a_ces.*(pmf.*labor_initial).^rho);
end
 


%   gamma_cd = gamma_bar_cd - eye(n_k);
e_tilde_tau_ge_cd=e_tilde_tau./(1+e_tilde);
e_tilde_ge_cd=e_tilde./(1+e_tilde);

e_tilde_tau_ge_ces=e_tilde_tau./(1+e_tilde./el_sub);

e_tilde_ge_ces=e_tilde./(1+e_tilde./el_sub);



%Now that everything is defined, solve the integral equation for all three
%cases (cobb douglas, ces and endogenous assignment)


A = eye(n_k);

A_cd = eye(n_k);

A_ces=eye(n_k);



tic

for i=1:n_k
    for j=1:n_k %change labor supply
        
        A(i,j)    =  A(i,j)    -  e_tilde(i) * gamma1(i,j);
        A_cd(i,j) =  A_cd(i,j) -  e_tilde_ge_cd(i) * gamma_bar_cd(i,j);
        A_ces(i,j) = A_ces(i,j) -  e_tilde_ge_ces(i) * gamma_bar_ces(i,j);
        
    end
end


toc

tic
for i=1:n_k
    
    B=zeros(n_k,1);
    B_cd=zeros(n_k,1);
    B_ces=zeros(n_k,1);
    
    B(i) =       -e_tilde_tau(i)*dtau/(1-t_prime(i));
    B_cd(i) =    -e_tilde_tau_ge_cd(i)*dtau/(1-t_prime(i));
    B_ces(i) =    -e_tilde_tau_ge_ces(i)*dtau/(1-t_prime(i));
    
    d_ln_l(:,i) = linsolve(A,B);
    d_ln_l_cd(:,i) = linsolve(A_cd,B_cd);
    d_ln_l_ces(:,i) = linsolve(A_ces,B_ces);
    
end
toc





for j=1:n_k
    for i=1:n_k
        d_ln_w(i,j) = sum(gamma1(i,:).*d_ln_l(:,j)') ;
        d_ln_w_cd(:,j) = gamma_bar_cd*d_ln_l_cd(:,j)-d_ln_l_cd(:,j);
        d_ln_w_ces(:,j) = gamma_bar_ces*d_ln_l_ces(:,j)+(rho-1)*d_ln_l_ces(:,j);
        
    end
end



%First get the mechanical and labor supply effect which are the same for
%all three scenarios since wages are kept fixed.

delta_y=    [(y(2:n_k)-y(1:n_k-1))';0];
delta_y(n_k)=delta_y(n_k-1);


for j=1:n_k
    mechanical(j) = delta_y(j)*dtau*(1-cdf(j));
    labor_supply(j) = y(j)*pmf(j)*e_tilde_tau(j)*t_prime(j)/(1-t_prime(j))*dtau;%it is defined as a tax loss. so it being negative means an increase in tax revenue
end




for j=1:n_k
    
    for i=1:n_k
        dy(i,j) = d_ln_l(i,j)*y(i) + d_ln_w(i,j)*y(i);
        dy_cd(i,j) = d_ln_l_cd(i,j)*y(i) + d_ln_w_cd(i,j)*y(i);
        dy_ces(i,j) = d_ln_l_ces(i,j)*y(i) + d_ln_w_ces(i,j)*y(i);
        
        if i==j
            
            dy(i,j)=   d_ln_l(i,j)*y(i) + d_ln_w(i,j)*y(i) + e_tilde_tau(i)*y(i)*dtau/(1-t_prime(j));
            dy_cd(i,j)=   d_ln_l_cd(i,j)*y(i) + d_ln_w_cd(i,j)*y(i) + e_tilde_tau(i)*y(i)*dtau/(1-t_prime(j));
            dy_ces(i,j)=   d_ln_l_ces(i,j)*y(i) + d_ln_w_ces(i,j)*y(i) + e_tilde_tau(i)*y(i)*dtau/(1-t_prime(j));
            
        end
        
        delta_tau(i,j)=t_prime(i)*dy(i,j);
        delta_tau_cd(i,j)=t_prime(i)*dy_cd(i,j);
        delta_tau_ces(i,j)=t_prime(i)*dy_ces(i,j);
        
    end
    
     
    ge_revenue(j) = - sum(pmf.*delta_tau(:,j));
    ge_revenue_cd(j) = - sum(pmf.*delta_tau_cd(:,j));
    ge_revenue_ces(j) = - sum(pmf.*delta_tau_ces(:,j));
    
end





%right panel of figure 3


hold off
set(gca,'FontSize',16)

p1=plot(income_initial/1000,1-labor_supply./mechanical)
set(p1,'Color','red','LineWidth',2);
xlim([0 500])
ylim([0.6 1])
hold on
p3=plot(income_initial/1000,1-labor_supply./mechanical-ge_revenue./mechanical);
set(p3,'Color','black','LineWidth',2,'LineStyle','--');
hold on
p3=plot(income_initial/1000,1-labor_supply./mechanical-ge_revenue_ces./mechanical);
set(p3,'Color','blue','LineWidth',2,'LineStyle',':');

ylabel('Revenue Effect');
h2=xlabel('$y^*$ in \$1,000' );


set(h2,'Interpreter','latex')


set(gca,'FontSize',16)

hleg1 = legend('Exogenous Wages', 'Costless Re-Assignment Ales et al. ','Fixed Assignment $\sigma=3.1$ ');

set(hleg1,'Interpreter','latex')


 
%left panel of figure 3


hold off
set(gca,'FontSize',16)

p1=plot(income_initial/1000,1-labor_supply./mechanical)
set(p1,'Color','red','LineWidth',2);
xlim([0 500])
ylim([.6 1])
hold on
p3=plot(income_initial/1000,1-labor_supply./mechanical-ge_revenue./mechanical);
set(p3,'Color','black','LineWidth',2,'LineStyle','--');
hold on
p3=plot(income_initial/1000,1-labor_supply./mechanical-ge_revenue_cd./mechanical);
set(p3,'Color','blue','LineWidth',2,'LineStyle',':');

ylabel('Revenue Effect');
h2=xlabel('$y^*$ in \$1,000' );


set(h2,'Interpreter','latex')
hold off
set(gca,'FontSize',16)

hleg1 = legend('Exogenous Wages', 'Costless Re-Assignment Ales et al. ','Fixed Assignment $\sigma=1$ ');

set(hleg1,'Interpreter','latex')





%Left panel of Figure 1
hold off
p1=plot(income_initial(1:n_k-1)/1000,gamma1(1:n_k-1,9)/pmf(9))
set(p1,'Color','red','LineWidth',2.5,'LineStyle',':');
%
hold on
p1=plot(income_initial(1:n_k-1)/1000,gamma1(1:n_k-1,30)/pmf(30))
set(p1,'Color','black','LineWidth',2.5,'LineStyle','--');
set(gca,'FontSize',18)
hold on
p1=plot(income_initial(1:n_k-1)/1000,gamma1(1:n_k-1,80)/pmf(80))
set(p1,'Color','blue','LineWidth',2.5,'LineStyle','-.');
set(gca,'FontSize',18)
hold on
xlim([0 500])
hleg1 = legend('$\gamma(y,\$25k)$ ', '$\gamma(y,\$80k)$' ,'$\gamma(y,\$200k)$' );
set(hleg1,'Interpreter','latex')

h= xlabel('$y$ in \$1,000');
set(h,'Interpreter','latex')
ylabel('Value of Cross Wage Elasticity')
set(gca,'FontSize',18)




%right panel of figure 1

hold off
p1=plot(income_initial(1:n_k-1)/1000,gamma1(1:n_k-1,30)/pmf(30) )
set(p1,'Color','red','LineWidth',2.5);
set(gca,'FontSize',18)
hold on
p1=plot(income_initial(1:n_k-1)/1000,gamma_bar_cd(1:n_k-1,30)/pmf(30) )
set(p1,'Color','black','LineWidth',2.5,'LineStyle','--');

set(gca,'FontSize',18)
hold on
p1=plot(income_initial(1:n_k-1)/1000,gamma_bar_ces(1:n_k-1,30)/pmf(30) )
set(p1,'Color','blue','LineWidth',2.5,'LineStyle','-.');

set(gca,'FontSize',18)
xlim([0 500])

hleg1 = legend('$\gamma(y,\$80k)$ Costless Reassignment','$\gamma(y,\$80k)$ Fixed Assignment $\sigma=1$', '$\gamma(y,\$80k)$ Fixed Assignment $\sigma=3.1$')
set(hleg1,'Interpreter','latex')

h= xlabel('$y$ in \$1,000');
set(h,'Interpreter','latex')
ylabel('Value of Cross Wage Elasticity')
set(gca,'FontSize',18)


set(hleg1,'Interpreter','latex')









