

function [tax1_i] = taxes_(l_help_i, i, theta, y_help, tax_marg);


y_help(i) = theta(i)*l_help_i;

% FIND THE HIGHEST j SUCH THAT y(j) IS LESS THAN y(i). THIS IS AKIN TO 
% FINDING THE iTH'S PERSON'S TAX BRACKET j, GIVEN i'S INCOME. IN THIS
% EXERCISE, THERE ARE EXACTLY i TAX BRACKETS SINCE WE CALCULATE EACH
% PERSON'S LABOR SUPPLY AS IF HIS ASSIGNED MARGINAL TAX RATE IS THE
% TAX RATE THAT APPLIES TO ALL INCOMES EARNED ABOVE y(i-1), OR ABOVE 0 IF
% i EQUALS 1. NOTE THAT IF y(1:i-1) IS NOT MONOTONIC, THIS ALGORITHM PUTS i
% INTO THE LOWEST POSSIBLE TAX BRACKET.

k = 1;
while ( (k ~= i)  &&  (y_help(k) < y_help(i)) )
    k = k+1;
end

% CALCULATE TAX PAID BY THIS iTH PERSON GIVEN HIS TAX BRACKET.
if (k==1)
    tax_paid_i =   tax_marg(1)*y_help(i);
elseif (k==2)
    tax_paid_i =   tax_marg(1)*y_help(1) + (tax_marg(1)*.5+tax_marg(2)*.5)*(y_help(i)-y_help(1));
else
    tax_paid_i =  tax_marg(1)*y_help(1) + sum( (tax_marg(1:k-2)*0.5+tax_marg(2:k-1)*0.5).*diff(y_help(1:k-1))) + (0.5*tax_marg(k-1)+0.5*tax_marg(k))*(y_help(i)-y_help(k-1));        
end

% CALCULATE RESULTING CONSUMPTION.
tax1_i= tax_paid_i;
end